"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var React = _interopRequireWildcard(require("react"));

var _Input = _interopRequireDefault(require("./Input"));

var _ErrorMessage = _interopRequireDefault(require("./ErrorMessage"));

var _FormContext = _interopRequireWildcard(require("./FormContext"));

var _FormControl = _interopRequireDefault(require("./_legacy/FormControl"));

var _utils = require("./utils");

var FormControl =
/*#__PURE__*/
function (_React$Component) {
  (0, _inheritsLoose2.default)(FormControl, _React$Component);

  function FormControl(_props, context) {
    var _this;

    _this = _React$Component.call(this, _props, context) || this;
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "handleFieldChange", function (formValue, value, event) {
      var _this$props = _this.props,
          name = _this$props.name,
          onChange = _this$props.onChange;
      var onFieldChange = _this.context.onFieldChange;

      var checkTrigger = _this.getCheckTrigger();

      var checkResult = _this.handleFieldCheck(formValue, value, checkTrigger === 'change');

      _this.setState({
        checkResult: checkResult,
        value: value
      });

      onFieldChange(name, value, event);
      onChange && onChange(value, event);
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "handleFieldBlur", function (formValue, event) {
      var _this$props2 = _this.props,
          onBlur = _this$props2.onBlur,
          name = _this$props2.name;

      var checkTrigger = _this.getCheckTrigger();

      var value = typeof formValue[name] === 'undefined' ? _this.state.value : formValue[name];

      _this.handleFieldCheck(formValue, value, checkTrigger === 'blur');

      onBlur && onBlur(event);
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "handleFieldCheck", function (formValue, value, isCheckTrigger, callback) {
      var name = _this.props.name;
      var _this$context = _this.context,
          onFieldError = _this$context.onFieldError,
          onFieldSuccess = _this$context.onFieldSuccess,
          model = _this$context.model;
      var checkResult = model.checkForField(name, value, formValue);

      if (isCheckTrigger) {
        if (checkResult.hasError) {
          onFieldError(name, checkResult.errorMessage, callback);
        } else {
          onFieldSuccess(name, callback);
        }
      }

      return checkResult;
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "addPrefix", function (name) {
      return (0, _utils.prefix)(_this.props.classPrefix)(name);
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "renderError", function (errorMessage) {
      var errorPlacement = _this.props.errorPlacement;
      var show = !!errorMessage;
      return React.createElement(_ErrorMessage.default, {
        show: show,
        className: _this.addPrefix('message-wrapper'),
        placement: errorPlacement
      }, errorMessage);
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "renderValue", function (formValue) {
      if (formValue === void 0) {
        formValue = {};
      }

      var _this$props3 = _this.props,
          name = _this$props3.name,
          Component = _this$props3.accepter,
          props = (0, _objectWithoutPropertiesLoose2.default)(_this$props3, ["name", "accepter"]);
      var _this$context$formDef = _this.context.formDefaultValue,
          formDefaultValue = _this$context$formDef === void 0 ? {} : _this$context$formDef;
      var unhandled = (0, _utils.getUnhandledProps)(FormControl, props);
      return React.createElement(Component, (0, _extends2.default)({}, unhandled, {
        name: name,
        onChange: _this.handleFieldChange.bind((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), formValue),
        onBlur: _this.handleFieldBlur.bind((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), formValue),
        defaultValue: formDefaultValue[name],
        value: formValue[name]
      }));
    });

    if (!context || !context.onFieldChange) {
      throw new Error("\n        <FormControl> must be inside a component decorated with <Form>.\n        And need to update React to 16.6.0 +.\n      ");
    }

    var _context$formValue = context.formValue,
        _formValue = _context$formValue === void 0 ? {} : _context$formValue,
        _context$formDefaultV = context.formDefaultValue,
        _formDefaultValue = _context$formDefaultV === void 0 ? {} : _context$formDefaultV;

    var _name = _props.name;
    _this.state = {
      checkResult: {},
      value: _formValue[_name] || _formDefaultValue[_name]
    };
    return _this;
  }

  var _proto = FormControl.prototype;

  _proto.getCheckTrigger = function getCheckTrigger() {
    var checkTrigger = this.context.checkTrigger;
    return this.props.checkTrigger || checkTrigger;
  };

  _proto.checkErrorFromContext = function checkErrorFromContext() {
    var _this2 = this;

    var errorFromContext = this.context.errorFromContext;
    var _this$props4 = this.props,
        name = _this$props4.name,
        errorMessage = _this$props4.errorMessage;

    if (errorMessage) {
      return this.renderError(errorMessage);
    }

    if (errorFromContext) {
      return React.createElement(_FormContext.FormErrorContext.Consumer, null, function (formError) {
        return _this2.renderError(formError[name]);
      });
    }

    return null;
  };

  _proto.render = function render() {
    return React.createElement("div", {
      className: this.addPrefix('wrapper')
    }, React.createElement(_FormContext.FormValueContext.Consumer, null, this.renderValue), this.checkErrorFromContext());
  };

  return FormControl;
}(React.Component);

(0, _defineProperty2.default)(FormControl, "contextType", _FormContext.default);
(0, _defineProperty2.default)(FormControl, "defaultProps", {
  accepter: _Input.default,
  errorPlacement: 'bottomLeft'
});
(0, _defineProperty2.default)(FormControl, "handledProps", ["accepter", "checkTrigger", "classPrefix", "errorMessage", "errorPlacement", "name", "onBlur", "onChange"]);
var EnhancedFormControl = (0, _utils.defaultProps)({
  classPrefix: 'form-control'
})(FormControl);

var _default = React.createContext ? EnhancedFormControl : _FormControl.default;

exports.default = _default;